# Flx Id Binder

Flx Id Api Binder for Dart

# Init
In main method invoke FlxId.init method async

For dart
``` dart
Future<void> main() async {
    FlxId.init();
}
```

For flutter
``` dart
void main() {
    WidgetsFlutterBinding.ensureInitialized();
    FlxId.init().then((value) => runApp(MyApp()));
}
```

Or invoke FlxId.init method before you invoke other methods from FlxId class

For example
``` dart
await FlxId.init();

await FlxId.oauth.signUp(
    firstName: "",
    lastName: "",
    nickname: "",
    password: "",
    email: "",
);

var result = await FlxId.oauth.signIn(
    email: "",
    password: "",
    appId: "",
    appSecret: "",
    deviceFingerprint: "",
    permissions: [ ],
);

// ...

```
