import 'package:get/get.dart';
import 'package:shared_preferences/shared_preferences.dart';

class ApiStorage extends GetxService {
  static const String _accessTokenName = "flx_id:access_token";
  static const String _refreshTokenName = "flx_id:refresh_token";
  static const String _deathDateName = "flx_id:death_date";

  SharedPreferences? _sharedPreferences;

  String? _accessToken;
  String? get accessToken => _accessToken;
  set accessToken(String? value) {
    if (value != null) {
      _sharedPreferences!.setString(_accessTokenName, value);
    } else {
      _sharedPreferences!.remove(_accessTokenName);
    }

    _accessToken = value;
  }

  String? _refreshToken;
  String? get refreshToken => _refreshToken;
  set refreshToken(String? value) {
    if (value != null) {
      _sharedPreferences!.setString(_refreshTokenName, value);
    } else {
      _sharedPreferences!.remove(_refreshTokenName);
    }

    _refreshToken = value;
  }

  DateTime? _deathDate;
  DateTime? get deathDate => _deathDate;
  set deathDate(DateTime? value) {
    if (value != null) {
      _sharedPreferences!.setInt(_deathDateName, value.millisecondsSinceEpoch);
    } else {
      _sharedPreferences!.remove(_deathDateName);
    }

    _deathDate = value;
  }

  Future init() async {
    _sharedPreferences = await SharedPreferences.getInstance();

    _accessToken = _sharedPreferences!.getString(_accessTokenName);
    _refreshToken = _sharedPreferences!.getString(_refreshTokenName);

    var deathDate = _sharedPreferences!.getInt(_deathDateName);
    if (deathDate != null) {
      _deathDate = DateTime.fromMillisecondsSinceEpoch(deathDate);
    }
  }
}
