enum AuthPermission {
  readNames,
  readEmail,
  readPhotos,
  readAchievements,
  readPrivacy,
  readApplications,
  manageNames,
  managePhotos,
  managePrivacy,
  manageApplications,
  updateEmail,
  updatePhone,
  updatePassword,
  permitAchievements,
  permitExitFromAllDevices,
}

class AuthPermissionConverter {
  static final Map<AuthPermission, int> _codes = {
    AuthPermission.readNames: 10,
    AuthPermission.readEmail: 11,
    AuthPermission.readPhotos: 12,
    AuthPermission.readAchievements: 13,
    AuthPermission.readPrivacy: 14,
    AuthPermission.readApplications: 15,
    AuthPermission.manageNames: 20,
    AuthPermission.managePhotos: 21,
    AuthPermission.managePrivacy: 22,
    AuthPermission.manageApplications: 23,
    AuthPermission.updateEmail: 30,
    AuthPermission.updatePhone: 31,
    AuthPermission.updatePassword: 32,
    AuthPermission.permitAchievements: 40,
    AuthPermission.permitExitFromAllDevices: 41,
  };

  static AuthPermission fromCode(int code) {
    return _codes.entries.firstWhere((element) => element.value == code).key;
  }

  static int fromEnum(AuthPermission permission) {
    return _codes.entries
        .firstWhere((element) => element.key == permission)
        .value;
  }
}

int code = AuthPermissionConverter.fromEnum(AuthPermission.readEmail);
AuthPermission permission = AuthPermissionConverter.fromCode(code);
