import 'package:flx_id_binder/flx_id_binder.dart';

class TokenModel {
  final String userId;
  final String accessToken;
  final String refreshToken;
  final DateTime createDate;
  final DateTime deathDate;
  final List<AuthPermission> permissions;

  TokenModel(
    this.userId,
    this.accessToken,
    this.refreshToken,
    this.createDate,
    this.deathDate,
    this.permissions,
  );

  TokenModel.fromJson(Map<dynamic, dynamic> json)
      : userId = json["userId"] as String,
        accessToken = json["accessToken"] as String,
        refreshToken = json["refreshToken"] as String,
        createDate = DateTime.parse(json["createDate"] as String),
        deathDate = DateTime.parse(json["deathDate"] as String),
        permissions = (json["grantedPermissions"] as List<dynamic>)
            .map((e) => AuthPermissionConverter.fromCode(e as int))
            .toList();
}
